/*
 *   -- micMAGMA (version 1.3.1) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      @date January 2015
 *
 *   @author Azzam Haidar
 *   @author Khairul Kabir
 *   @author Stan Tomov
 *   @author Hartwig Anzt
 *
 *   @generated from magma_z_bindings.h normal z -> c, Fri Jan 30 18:21:53 2015
 */


#ifndef MAGMA_C_BINDINGS
#define MAGMA_C_BINDINGS


typedef struct {
    magma_trans_t transa;
    magma_int_t m;
    magmaFloatComplex_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaFloatComplex_const_ptr x;
    magmaFloatComplex_ptr y;
} magma_mic_ccsrgemv_param;

typedef struct {
    magma_trans_t transa;
    magma_int_t request;
    magma_int_t sort;
    magma_int_t  m;
    magma_int_t  n;
    magma_int_t  k;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magmaIndex_const_ptr ia;
    magmaIndex_const_ptr ja;
    magmaFloatComplex_const_ptr b;
    magmaIndex_const_ptr ib;
    magmaIndex_const_ptr jb;
    magmaFloatComplex_ptr c;
    magmaIndex_ptr ic;
    magmaIndex_ptr jc;
    magma_int_t nzmax;
    magma_int_t info;
} magma_mic_ccsrgespmm_param;

typedef struct {
    magmaFloatComplex_ptr res;
    magma_int_t n;
    magmaFloatComplex_const_ptr x;
    magma_int_t incx;
    magmaFloatComplex_const_ptr y;
    magma_int_t incy;
} magma_mic_cdotc_param;

typedef struct {
    magmaFloat_ptr res;
    magma_int_t n;
    magmaFloatComplex_const_ptr x;
    magma_int_t incx;
} magma_mic_scnrm2_param;

typedef struct {
    magma_int_t n;
    magmaFloatComplex a;
    magmaFloatComplex_const_ptr x;
    magma_int_t incx;
    magmaFloatComplex_ptr y;
    magma_int_t incy;
} magma_mic_caxpy_param;

typedef struct {
    magma_int_t n;
    magmaFloatComplex_const_ptr x;
    magma_int_t incx;
    magmaFloatComplex_ptr y;
    magma_int_t incy;
} magma_mic_ccopy_param;

typedef struct {
    magma_trans_t transa;
    magma_trans_t transb;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magmaFloatComplex_const_ptr b;
    magma_int_t ldb;
    magmaFloatComplex beta;
    magmaFloatComplex_const_ptr c;
    magma_int_t ldc;
} magma_mic_cgemm_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magmaFloatComplex_const_ptr b;
    magma_int_t ldb;
    magmaFloatComplex beta;
    magmaFloatComplex_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_chemm_param;

typedef struct {
    magma_trans_t transa;
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magmaFloatComplex_const_ptr x;
    magma_int_t incx;
    magmaFloatComplex beta;
    magmaFloatComplex_const_ptr y;
    magma_int_t incy;
} magma_mic_cgemv_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magmaFloatComplex_const_ptr x;
    magma_int_t incx;
    magmaFloatComplex beta;
    magmaFloatComplex_const_ptr y;
    magma_int_t incy;
} magma_mic_chemv_param;




typedef struct {
    magma_int_t n;
    magmaFloatComplex_const_ptr d_A;
    magma_int_t lda;
    magmaFloatComplex_const_ptr d_u;
    magmaFloatComplex_const_ptr d_v;
} magma_mic_cprbt_param;


typedef struct {
    magma_int_t n;
    magmaFloatComplex_const_ptr d_u;
    magmaFloatComplex_const_ptr d_b;
} magma_mic_cprbt_mtv_param;


typedef struct {
    magma_int_t n;
    magmaFloatComplex_const_ptr d_v;
    magmaFloatComplex_const_ptr d_b;
} magma_mic_cprbt_mv_param;


typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magmaFloatComplex_const_ptr x;
    magma_int_t incx;
    magmaFloatComplex beta;
    magmaFloatComplex_const_ptr y;
    magma_int_t incy;
} magma_mic_csymv2_param;



typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    float beta;
    magmaFloatComplex_const_ptr c;
    magma_int_t ldc;
} magma_mic_cherk_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    float beta;
    magmaFloatComplex_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_cherk_mmic_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magmaFloatComplex_const_ptr b;
    magma_int_t ldb;
    float beta;
    magmaFloatComplex_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_cher2k_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    magmaFloatComplex_const_ptr b;
    magma_int_t ldb;
    magma_int_t boff;
    float beta;
    magmaFloatComplex_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_cher2k_mmic_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magmaFloatComplex_const_ptr b;
    magma_int_t ldb;
} magma_mic_ctrsm_param;

typedef struct {
    magma_mic_ctrsm_param trsm_param;
    magma_mic_cgemm_param gemm_param;
} magma_mic_ctrsmgemm_param;

typedef struct {
  magma_uplo_t uplo;
  magma_trans_t trans;
  magma_diag_t diag;
  magma_int_t n;
  magmaFloatComplex alpha;
  magmaFloatComplex_const_ptr a;
  magma_int_t lda;
  magmaFloatComplex_const_ptr dx;
  magma_int_t incx;
} magma_mic_ctrsv_param;

typedef struct {
  magma_uplo_t  uplo;
  magma_trans_t trans;
  magma_diag_t  diag;
  magma_int_t n;
  magmaFloatComplex alpha;
  magmaFloatComplex_const_ptr a;
  magma_int_t lda;
  magmaFloatComplex_const_ptr dx;
  magma_int_t incx;
} magma_mic_ctrmv_param;
 
typedef struct {
    magma_uplo_t uplo;
    magma_int_t n; 
    magma_int_t nb; 
    magma_int_t *kb;
    magmaFloatComplex *hA;
    magma_int_t lda;
    magmaFloatComplex_ptr dA;
    magma_int_t ldda;
    magma_int_t *ipiv;
    magmaFloatComplex_ptr dW;
    magma_int_t lddw;
} magma_mic_clahef_param;

typedef struct {
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t n;
    magma_int_t k;
    magmaFloatComplex_const_ptr v;
    magma_int_t ldv;
    magmaFloatComplex_const_ptr tau;
    magmaFloatComplex_const_ptr t;
    magma_int_t ldt;
} magma_mic_clarft_param;


typedef struct {
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaFloatComplex_const_ptr v;
    magma_int_t ldv;
    magmaFloatComplex_const_ptr t;
    magma_int_t ldt;
    magmaFloatComplex_const_ptr c;
    magma_int_t ldc;
    magmaFloatComplex_const_ptr work;
    magma_int_t ldwork;
} magma_mic_clarfb_param;

typedef struct {
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaFloatComplex_const_ptr v;
    magma_int_t ldv;
    magmaFloatComplex_const_ptr t;
    magma_int_t ldt;
    magmaFloatComplex_const_ptr c;
    magma_int_t ldc;
    magmaFloatComplex_const_ptr work;
    magma_int_t ldwork;
    magmaFloatComplex_const_ptr workvt;
    magma_int_t ldworkvt;
} magma_mic_clarfb_gemm_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex alpha;
    magmaFloatComplex beta;
    magmaFloatComplex_const_ptr dA;
    magma_int_t lda;
} magma_mic_claset_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex alpha;
    magmaFloatComplex_const_ptr a;
    magma_int_t lda;
    magmaFloatComplex_const_ptr b;
    magma_int_t ldb;
} magma_mic_ctrmm_param;


typedef struct {
    magmaFloatComplex_const_ptr odata;
    magma_int_t ldo;
    magmaFloatComplex_const_ptr idata;
    magma_int_t ldi;
    magma_int_t m;
    magma_int_t n;
} magma_mic_ctranspose_param;


/*
typedef struct {
    magmaFloatComplex_const_ptr d_AT;
    magma_int_t lda;
    magma_int_t *d_ipiv;
    magma_int_t nb;
    magma_int_t ind;
} magma_mic_claswp_param;
*/


typedef struct {
    magma_int_t n;
    magmaFloatComplex_const_ptr d_A;
    magma_int_t lda;
    magma_int_t k1;
    magma_int_t k2;
    magma_int_t *d_ipiv;
    magma_int_t incx;
} magma_mic_claswp_param;


typedef struct {
    magma_int_t n;
    magmaFloatComplex *dA1T;
    magma_int_t lda1;
    magmaFloatComplex *dA2T;
    magma_int_t lda2;
} magma_mic_cswap_param;

typedef struct {
    magma_norm_t norm;
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex_const_ptr dA; 
    magma_int_t ldda;
    magmaFloat_ptr dwork;
    float *ret;
} magma_mic_clange_param;


typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex_const_ptr dA;
    magma_int_t ldda;
    magmaFloatComplex_ptr dB;
    magma_int_t lddb;
} magma_mic_clacpy_param;


typedef struct {
    magma_int_t n;
    magmaFloatComplex alpha;
    magmaFloatComplex_ptr dx;
    magma_int_t incx;
} magma_mic_cscal_param;


typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex_ptr dA;
    magma_int_t ldda;
    magmaFloatComplex_ptr dB;
    magma_int_t lddb;
} magma_mic_clascl_diag_param;


typedef struct {
    magma_int_t n;
    magmaFloatComplex_const_ptr dx; 
    magma_int_t incx;
    magma_int_t *ret;
} magma_mic_icamax_param;

typedef struct {
    magma_int_t m;
    magmaFloatComplex *r; 
    magmaFloatComplex *x; 
    magmaFloatComplex *b; 
} magma_mic_caxpycp2_param;



// SPARSE

typedef struct {
    magma_int_t m;
    magma_int_t n;
    magmaFloatComplex_ptr d;
    magmaFloatComplex_ptr b;
    magmaFloatComplex_ptr c;
} magma_mic_cjacobidiagscale_param;


#endif  // MAGMA_C_BINDINGS
