/*
 *   -- micMAGMA (version 1.3.1) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 * @author Azzam Haidar
 * @author Khairul Kabir
 *
 * @generated from magma_z_server.cpp normal z -> s, Fri Jan 30 18:21:54 2015
 */

#include <mkl.h>

#include <mkl_trans.h>
#include <scif.h>
#include <fcntl.h>
#include <offload.h>

//#ifdef __MIC__
//#define _M512_TYPED
//#include <lmmintrin.h>
//#endif
#include <immintrin.h>


#include "magma.h"
//#include "magma_s_bindings.h"
#include "magma_s_server.h"

#define min(a, b) ((a) < (b) ? (a) : (b))

#define PRECISION_s
#define REAL

void magmablas_selementary_multiplication(
    magma_int_t n,
    float *dA, magma_int_t ldda, 
    float *du, float *dv)
{    

    magma_int_t idx, idy;


	float *dAt;
#pragma omp parallel for  
	for(idy = 0 ; idy < n/2; idy++)
	{
		for(idx = 0; idx < n/2; idx++)
		{


			float b1, b2, b3, b4;



			b1 = dA[idx + idy * ldda] + dA[idx + ldda*(idy+n/2)];
			b2 = dA[idx + n/2 + idy* ldda] + dA[idx+n/2 + ldda*(idy+n/2)];
			b3 = dA[idx + idy * ldda] - dA[idx + ldda*(idy+n/2)];
			b4 = dA[idx + n/2 + idy* ldda] - dA[idx+n/2 + ldda*(idy+n/2)];


			
			
			dA[idx + idy * ldda] = du[idx] * dv[idy] * (b1 + b2);
			dA[idx + ldda*(idy+n/2)] = du[idx] * dv[idy+n/2] * (b3 + b4);
			dA[idx + n/2 + idy* ldda] = du[idx+ n/2] * dv[idy] * (b1 - b2);
			dA[idx+n/2 + ldda*(idy+n/2)] = du[idx+n/2] * dv[idy+n/2] *(b3 - b4);
		}
	}
}
#if 0
__m512d mulDoubleComp(__m512d a, __m512d b) 
{
    __m512d b_flip = _mm512_shuffle_pd(b,b,0x55);   // Swap b.re and b.im

    __m512d a_im   = _mm512_shuffle_pd(a,a,0xFF);   // Imag. part of a in both

    __m512d a_re   = _mm512_shuffle_pd(a,a,0x00);   // Real part of a in both

    __m512d aib    = _mm512_mul_pd(a_im, b_flip);   // (a.im*b.im, a.im*b.re)


    return  _mm512_fmaddsub_pd(a_re, b, aib);      

}

void 
magmablas_selementary_multiplication0(
        magma_int_t n,
        float *dA, magma_int_t ldda,
        float *du, float *dv)
{    
    magma_int_t idx, idy;

#pragma omp parallel for
    for(idy = 0 ; idy < n/2; idy++)
    {
        __m512d dv1, dv2;
        dv1 = _mm512_set_pd(MAGMA_S_IMAG(dv[idy]),MAGMA_S_REAL(dv[idy]),
                MAGMA_S_IMAG(dv[idy]),MAGMA_S_REAL(dv[idy]),
                MAGMA_S_IMAG(dv[idy]),MAGMA_S_REAL(dv[idy]),
                MAGMA_S_IMAG(dv[idy]),MAGMA_S_REAL(dv[idy]));
        dv2 = _mm512_set_pd(MAGMA_S_IMAG(dv[idy+n/2]),MAGMA_S_REAL(dv[idy+n/2]),
                MAGMA_S_IMAG(dv[idy+n/2]),MAGMA_S_REAL(dv[idy+n/2]),
                MAGMA_S_IMAG(dv[idy+n/2]),MAGMA_S_REAL(dv[idy+n/2]),
                MAGMA_S_IMAG(dv[idy+n/2]),MAGMA_S_REAL(dv[idy+n/2]));

        for(idx = 0; idx < n/2; idx+=4)
        {
            __m512d b1, b2, b3, b4, a0, a1, a2, a3 ;
		//	__m512d b5, b6, b7, b8;
	

			a0 = _mm512_load_pd(&dA[idx + idy * ldda]);
			a1 = _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]);
			a2 = _mm512_load_pd(&dA[idx + n/2 + idy* ldda]);
			a3 = _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]);


			b1 =_mm512_add_pd( a0 ,a1);
			b2 = _mm512_add_pd( a2, a3);
			b3 = _mm512_sub_pd(a0 , a1);
			b4 = _mm512_sub_pd(a2 ,  a3);

		//	b1 =_mm512_add_pd( _mm512_load_pd(&dA[idx + idy * ldda]) , _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]));
		//	b2 = _mm512_add_pd(  _mm512_load_pd(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]));
		//	b3 = _mm512_sub_pd( _mm512_load_pd(&dA[idx + idy * ldda]) ,  _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]));
		//	b4 = _mm512_sub_pd( _mm512_load_pd(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]));

			__m512d du1, du2;

			du1 = _mm512_load_pd(&du[idx]);
			du2 = _mm512_load_pd(&du[idx+n/2]);

			_mm512_store_pd(&dA[idx + idy * ldda] , mulDoubleComp(du1 , mulDoubleComp(dv1 , _mm512_add_pd(b1,  b2))));
			_mm512_store_pd(&dA[idx + ldda*(idy+n/2)] , mulDoubleComp( du1 , mulDoubleComp( dv2 , _mm512_add_pd(b3 , b4))));
			_mm512_store_pd(&dA[idx + n/2 + idy* ldda] , mulDoubleComp(du2 , mulDoubleComp(dv1 , _mm512_sub_pd(b1 , b2))));
			_mm512_store_pd(&dA[idx+n/2 + ldda*(idy+n/2)] , mulDoubleComp(du2 , mulDoubleComp( dv2 , _mm512_sub_pd(b3 , b4))));
		}
	}
}
#endif


#ifndef COMPLEX
#ifdef PRECISION_d
void 
magmablas_selementary_multiplication0(
    magma_int_t n,
    float *dA, magma_int_t ldda,
    float *du, float *dv)
{    
	magma_int_t idx, idy;

#pragma omp parallel for
	for(idy = 0 ; idy < n/2; idy++)
	{
		__m512d dv1, dv2;
		dv1 = _mm512_set1_pd(dv[idy]);
		dv2 = _mm512_set1_pd(dv[idy+n/2]);

		for(idx = 0; idx < n/2; idx+=8)
		{
			__m512d b1, b2, b3, b4, a0, a1, a2, a3 ;
		//	__m512d b5, b6, b7, b8;
	

			a0 = _mm512_load_pd(&dA[idx + idy * ldda]);
			a1 = _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]);
			a2 = _mm512_load_pd(&dA[idx + n/2 + idy* ldda]);
			a3 = _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]);


			b1 =_mm512_add_pd( a0 ,a1);
			b2 = _mm512_add_pd( a2, a3);
			b3 = _mm512_sub_pd(a0 , a1);
			b4 = _mm512_sub_pd(a2 ,  a3);

		//	b1 =_mm512_add_pd( _mm512_load_pd(&dA[idx + idy * ldda]) , _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]));
		//	b2 = _mm512_add_pd(  _mm512_load_pd(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]));
		//	b3 = _mm512_sub_pd( _mm512_load_pd(&dA[idx + idy * ldda]) ,  _mm512_load_pd(&dA[idx + ldda*(idy+n/2)]));
		//	b4 = _mm512_sub_pd( _mm512_load_pd(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_pd(&dA[idx+n/2 + ldda*(idy+n/2)]));

			__m512d du1, du2;

			du1 = _mm512_load_pd(&du[idx]);
			du2 = _mm512_load_pd(&du[idx+n/2]);

			_mm512_store_pd(&dA[idx + idy * ldda] , _mm512_mul_pd(du1 , _mm512_mul_pd(dv1 , _mm512_add_pd(b1,  b2))));
			_mm512_store_pd(&dA[idx + ldda*(idy+n/2)] , _mm512_mul_pd( du1 , _mm512_mul_pd( dv2 , _mm512_add_pd(b3 , b4))));
			_mm512_store_pd(&dA[idx + n/2 + idy* ldda] , _mm512_mul_pd(du2 , _mm512_mul_pd(dv1 , _mm512_sub_pd(b1 , b2))));
			_mm512_store_pd(&dA[idx+n/2 + ldda*(idy+n/2)] , _mm512_mul_pd(du2 , _mm512_mul_pd( dv2 , _mm512_sub_pd(b3 , b4))));
		}
	}
}
#else

void magmablas_selementary_multiplication0(
    magma_int_t n,
    float *dA, magma_int_t ldda,
    float *du, float *dv)
{    
	magma_int_t idx, idy;

#pragma omp parallel for
	for(idy = 0 ; idy < n/2; idy++)
	{
		__m512 dv1, dv2;
		dv1 = _mm512_set1_ps(dv[idy]);
		dv2 = _mm512_set1_ps(dv[idy+n/2]);

		for(idx = 0; idx < n/2; idx+=16)
		{
			__m512 b1, b2, b3, b4, a0, a1, a2, a3 ;
		//	__m512 b5, b6, b7, b8;
	

			a0 = _mm512_load_ps(&dA[idx + idy * ldda]);
			a1 = _mm512_load_ps(&dA[idx + ldda*(idy+n/2)]);
			a2 = _mm512_load_ps(&dA[idx + n/2 + idy* ldda]);
			a3 = _mm512_load_ps(&dA[idx+n/2 + ldda*(idy+n/2)]);


			b1 =_mm512_add_ps( a0 ,a1);
			b2 = _mm512_add_ps( a2, a3);
			b3 = _mm512_sub_ps(a0 , a1);
			b4 = _mm512_sub_ps(a2 ,  a3);

		//	b1 =_mm512_add_ps( _mm512_load_ps(&dA[idx + idy * ldda]) , _mm512_load_ps(&dA[idx + ldda*(idy+n/2)]));
		//	b2 = _mm512_add_ps(  _mm512_load_ps(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_ps(&dA[idx+n/2 + ldda*(idy+n/2)]));
		//	b3 = _mm512_sub_ps( _mm512_load_ps(&dA[idx + idy * ldda]) ,  _mm512_load_ps(&dA[idx + ldda*(idy+n/2)]));
		//	b4 = _mm512_sub_ps( _mm512_load_ps(&dA[idx + n/2 + idy* ldda]) ,  _mm512_load_ps(&dA[idx+n/2 + ldda*(idy+n/2)]));

			__m512 du1, du2;

			du1 = _mm512_load_ps(&du[idx]);
			du2 = _mm512_load_ps(&du[idx+n/2]);

			_mm512_store_ps(&dA[idx + idy * ldda] , _mm512_mul_ps(du1 , _mm512_mul_ps(dv1 , _mm512_add_ps(b1,  b2))));
			_mm512_store_ps(&dA[idx + ldda*(idy+n/2)] , _mm512_mul_ps( du1 , _mm512_mul_ps( dv2 , _mm512_add_ps(b3 , b4))));
			_mm512_store_ps(&dA[idx + n/2 + idy* ldda] , _mm512_mul_ps(du2 , _mm512_mul_ps(dv1 , _mm512_sub_ps(b1 , b2))));
			_mm512_store_ps(&dA[idx+n/2 + ldda*(idy+n/2)] , _mm512_mul_ps(du2 , _mm512_mul_ps( dv2 , _mm512_sub_ps(b3 , b4))));
		}
	}
}

#endif
#endif
void magmablas_sapply_vector(float *du, float *db, magma_int_t n)
{
	magma_int_t idx;

//	#pragma omp parallel for
	for(idx = 0; idx < n/2; idx++)
	{


		float a1,a2;

		a1 = du[idx]*db[idx];
		a2 = du[idx+n/2]*db[idx+n/2];

		db[idx] = a1 + a2;
		db[idx+n/2] = a1 -a2;
	}
}

void magmablas_sapply_transpose_vector(float *du, float *db, magma_int_t n)
{
	int idx;


//	#pragma omp parallel for
	for(idx = 0; idx < n/2; idx++)
	{


		float a1,a2;

		a1 = db[idx] + db[idx+n/2];
		a2 = db[idx] - db[idx+n/2];

		db[idx] = du[idx]*a1;
		db[idx+n/2] = du[idx+n/2]*a2;
	}
}



void sprbt(
    magma_int_t n, 
    float *d_A, magma_int_t ldda, 
    float *d_u, float *d_v)
{
	/*
	 *
	 * */
	d_u += ldda;
	d_v += ldda;
	
#ifdef COMPLEX
    magmablas_selementary_multiplication(n/2, d_A, ldda, d_u, d_v);
	magmablas_selementary_multiplication(n/2, d_A+ldda*n/2, ldda, d_u, d_v+n/2);
	magmablas_selementary_multiplication(n/2, d_A+n/2, ldda, d_u+n/2, d_v);
	magmablas_selementary_multiplication(n/2, d_A+ldda*n/2+n/2, ldda, d_u+n/2, d_v+n/2);
	magmablas_selementary_multiplication(n, d_A, ldda, d_u-ldda, d_v-ldda);
#else
    magmablas_selementary_multiplication0(n/2, d_A, ldda, d_u, d_v);
	magmablas_selementary_multiplication0(n/2, d_A+ldda*n/2, ldda, d_u, d_v+n/2);
	magmablas_selementary_multiplication0(n/2, d_A+n/2, ldda, d_u+n/2, d_v);
	magmablas_selementary_multiplication0(n/2, d_A+ldda*n/2+n/2, ldda, d_u+n/2, d_v+n/2);
	magmablas_selementary_multiplication0(n, d_A, ldda, d_u-ldda, d_v-ldda);
#endif
}



void sprbt_mtv(
    magma_int_t n, 
    float *d_u, float *d_b)
{
	/*
	 *
	 * */
	magmablas_sapply_transpose_vector(d_u+n,    d_b,n/2);
	magmablas_sapply_transpose_vector(d_u+n+n/2,d_b+n/2,n/2);

	magmablas_sapply_transpose_vector(d_u,d_b,n);
}



void sprbt_mv(
    magma_int_t n, 
    float *d_v, float *d_b)
{
	/*
	 *
	 * */

	magmablas_sapply_vector(d_v,d_b,n);



	magmablas_sapply_vector(d_v+n,    d_b,n/2);
	magmablas_sapply_vector(d_v+n+n/2,d_b+n/2,n/2);


}


void call_sprbt(magma_mic_sprbt_param param)
{
	magma_int_t n, ldda;
	float* dA, *du, *dv;
	n = param.n;
	dA = (float*) param.d_A;
	ldda = param.lda;
	du = (float*)param.d_u;
	dv = (float*)param.d_v;

	sprbt(n, dA, ldda, du, dv);
}



void call_sprbt_mtv(magma_mic_sprbt_mtv_param param)
{
	magma_int_t n;
	float *du, *db;
	n = param.n;
	du = (float*)param.d_u;
	db = (float*)param.d_b;

	sprbt_mtv(n, du, db);
}

void call_sprbt_mv(magma_mic_sprbt_mv_param param)
{
	magma_int_t n;
	float *dv, *db;
	n = param.n;
	dv = (float*)param.d_v;
	db = (float*)param.d_b;

	sprbt_mv(n, dv, db);
}

//=========================================================================================
#ifdef PRECISION_z
typedef struct {
    magma_int_t n;
    magma_int_t elemSize;
    void const* dx_src;
    magma_int_t incx;
    void*      dy_dst;
    magma_int_t incy;
} magma_mic_vcopy_param;

typedef struct {
    magma_int_t m;
    magma_int_t n;
    magma_int_t elemSize;
    void const* dA_src;
    magma_int_t lda;
    void*       dB_dst;
    magma_int_t ldb;
} magma_mic_mcopy_param;

void call_vcopy(magma_mic_vcopy_param param)
{
    magma_int_t n        = param.n;
    magma_int_t elemSize = param.elemSize;
    void const* dx_src   = param.dx_src;
    magma_int_t incx     = param.incx; 
    void*       dy_dst   = param.dy_dst; 
    magma_int_t incy     = param.incy;

    /* sequential version */
    magma_int_t ix=0, iy=0;
    for (magma_int_t i=0; i < n; i++) {
        memcpy(dy_dst+iy, dx_src+ix, elemSize);
        ix += incx*elemSize;
        iy += incy*elemSize;
    }
}

void call_mcopy(magma_mic_mcopy_param param)
{
    magma_int_t m        = param.m;
    magma_int_t n        = param.n;
    magma_int_t elemSize = param.elemSize;
    void const* dA_src   = param.dA_src;
    magma_int_t lda      = param.lda;
    void*       dB_dst   = param.dB_dst;
    magma_int_t ldb      = param.ldb;

    /* sequential version */
    magma_int_t ix=0, iy=0;
    for (magma_int_t i=0; i < n; i++) {
        memcpy(dB_dst + i*ldb*elemSize, dA_src + i*lda*elemSize, m*elemSize);
    }
}
#endif

//=========================================================================================
void call_scopy(magma_mic_scopy_param param)
{
    magma_int_t n, incx, incy;
    float  *x, *y;
    
    n      = param.n;
    x      = (float *)param.x;
    incx   = param.incx;
    y      = (float *)param.y;
    incy   = param.incy;
    
    /* sequential version I think the compiler is optimizing it */
    magma_int_t ix=0, iy=0, ii, chunk=1, nthreads, tid;
    /*if (incx < 0) ix = (-n+1)*incx;
    if (incy < 0) iy = (-n+1)*incy;
    #pragma ivdep
    #pragma simd
    for (magma_int_t i=0; i < n; i++) {
           y[iy] = x[ix];
           ix += incx;
           iy += incy;
    }*/

    /* parallel version, where I use openmp to parallelize the copy */
 /* not tested if incx or incy < 0i*/
    #pragma omp parallel
    {
        magma_int_t ix=0, iy=0, ii, nthreads, tid;
        tid      = omp_get_thread_num();
        nthreads = omp_get_num_threads();
        if (incx < 0) ix = (-n+1)*incx;
        if (incy < 0) iy = (-n+1)*incy;
        ix = ix + tid*incx;
        iy = iy + tid*incy;
        for (ii=0; ii < n; ii += nthreads) {
            if ((ii+tid) < n) {
                y[iy] = x[ix];
                ix = ix + incx * nthreads;
                iy = iy + incy * nthreads;
            }
        }
    }

    // mkl_scopy is not optimized yet and thus giving bad perf.
    // it is better to use the handcode as the compiler is intelligent and
    // optimizes the code better. Azzam
    //scopy( &n, (float *)x, &incx, (float *)y, &incy);
}


//=========================================================================================
//magmablas our ssymm only left implemented here Azzam
//=========================================================================================
void magmablas_ssymm_mic(
    magma_side_t side, magma_uplo_t uplo, magma_int_t n, magma_int_t k, magma_int_t nb,
    float alpha, float *a, magma_int_t lda,
                              float *b, magma_int_t ldb,
    float beta,  float *c, magma_int_t ldc, magma_int_t agboff)
{
    #define dA(i, j) (a + (i) + (j)*lda)
    #define dB(i, j) (b + (i) + (j)*ldb)
    #define dC(i, j) (c + (i) + (j)*ldc)

    const float c_one = MAGMA_S_ONE;
    float newbeta = beta;
    magma_int_t m, ib, ioff, blockoffset;
    // loop over all blocks and does A*A'
    // blockoffset is offset within first block; for subsequent blocks it is 0
    blockoffset = agboff % nb;
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        /*
        // Symmetrize the upper part of this block
        for (magma_int_t col=0; col < ib; col++) {
            for (magma_int_t row=0; row < col; row++) {
                *dA(i+row, i+col) =  MAGMA_S_CNJG( *(dA(i+col, i+row)) );
            }
        }
        */
        // C[i:n,0] += alpha * A[i:n,i] * B[i,0]
        /*
        m = n - i -ib;
        ssymm( lapack_const(side), lapack_const(uplo),
              &ib, &k, (const float *)&alpha, (float *)(dA(i, i)), &lda,
              (float *)(dB(i,0)), &ldb, (const float *)&newbeta,
              (float *)(dC(i,0)), &ldc);

        sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaNoTrans), &m, &k, &ib,
               (const float *)&alpha,   (float *)(dA(ioff+ib, ioff)), &lda,
                                                (float *)(dB(i,0)),           &ldb,
               (const float *)&newbeta, (float *)(dC(i+ib,0)),        &ldc );
        */
        m = n - i;
        sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaNoTrans), &m, &k, &ib,
               (const float *)&alpha,   (float *)(dA(i,i)), &lda,
                                                (float *)(dB(i,0)), &ldb,
               (const float *)&newbeta, (float *)(dC(i,0)), &ldc );
        

        sgemm( lapack_const(MagmaConjTrans), lapack_const(MagmaNoTrans), &i, &k, &ib,
               (const float *)&alpha,   (float *)(dA(i,0)), &lda,
                                                (float *)(dB(i,0)), &ldb,
               (const float *)&newbeta, (float *)(dC(0,0)), &ldc );

        newbeta = c_one;
        blockoffset = 0;
    }
    
    #undef dA
    #undef dB
    #undef dC
}

//=========================================================================================
void call_ssymm(magma_mic_ssymm_param param)
{
    magma_side_t side;
    magma_uplo_t uplo;
    magma_int_t m, n, lda, ldb, ldc, agboff;
    float alpha, beta, *a, *b, *c;

    side   = param.side;
    uplo   = param.uplo;
    m      = param.m;
    n      = param.n;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    b      = (float *)param.b;
    ldb    = param.ldb;
    beta   = param.beta;
    c      = (float *)param.c;
    ldc    = param.ldc;
    agboff = param.agboff;
    
    if ((side == MagmaLeft) && (uplo == MagmaLower)) {
        //printf("calling AZZAM SYMM m %d   n %d   agboff %d\n", m, n, agboff);
        //Azzam: calling only the Left Lower. need to be developed for all cases
        magma_int_t nb = 960;
        magmablas_ssymm_mic(side, uplo,
                         m, n, nb, alpha, a, lda, b, ldb,
                         beta, c, ldc, agboff);
    } else {
        //printf("calling MKL SYMM m %d   n %d \n", m, n);
        ssymm( lapack_const(side), lapack_const(uplo),
               &m, &n, (const float *)&alpha, (float *)a, &lda,
               (float *)b, &ldb, (const float *)&beta,
               (float *)c, &ldc);
    }
}

//=========================================================================================
void call_sgemm(magma_mic_sgemm_param param)
{
    magma_trans_t transa, transb;
    magma_int_t m, n, k, lda, ldb, ldc;
    float alpha, beta, *a, *b, *c;
    
    transa = param.transa;
    transb = param.transb;
    m      = param.m;
    n      = param.n;
    k      = param.k;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    b      = (float *)param.b;
    ldb    = param.ldb;
    beta   = param.beta;
    c      = (float *)param.c;
    ldc    = param.ldc;

    //printf("SGEMM: %c %c %d %d %d %f 0x%lx %d 0x%lx %d %f 0x%lx %d\n", transa, transb, m, n, k, alpha, (off_t)a, lda, (off_t)b, ldb, beta, (off_t)c, ldc);

    sgemm( lapack_const(transa), lapack_const(transb),
           &m, &n, &k, (const float *)&alpha, (float *)a, &lda,
           (float *)b, &ldb, (const float *)&beta,
           (float *)c, &ldc);
}

//=========================================================================================
void call_sgemv(magma_mic_sgemv_param param)
{
    magma_trans_t transa;
    magma_int_t m, n, lda, incx, incy;
    float alpha, beta, *a, *x, *y;
    
    transa = param.transa;
    m      = param.m;
    n      = param.n;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    x      = (float *)param.x;
    incx   = param.incx;
    beta   = param.beta;
    y      = (float *)param.y;
    incy   = param.incy;
    
    //printf("SGEMV: %c %c %d %d %d %f 0x%lx %d 0x%lx %d %f 0x%lx %d\n", transa, transb, m, n, k, alpha, (off_t)a, lda, (off_t)b, ldb, beta, (off_t)c, ldc);
    
    sgemv( lapack_const(transa), &m, &n, (const float *)&alpha,
           (float *)a, &lda, (float *)x, &incx,
           (const float *)&beta, (float *)y, &incy);
}

//=========================================================================================
void call_ssymv(magma_mic_ssymv_param param)
{
    magma_uplo_t uplo;
    magma_int_t n, lda, incx, incy;
    float alpha, beta, *a, *x, *y;
    
    uplo   = param.uplo;
    n      = param.n;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    x      = (float *)param.x;
    incx   = param.incx;
    beta   = param.beta;
    y      = (float *)param.y;
    incy   = param.incy;
    
    ssymv( lapack_const(uplo), &n, (const float *)&alpha,
           (float *)a, &lda, (float *)x, &incx,
           (const float *)&beta, (float *)y, &incy);
}

//=========================================================================================
void call_ssymv2(magma_mic_ssymv2_param param)
{
    magma_uplo_t uplo;
    magma_int_t n, lda, incx, incy;
    float alpha, beta, *a, *x, *y;
    
    uplo   = param.uplo;
    n      = param.n;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    x      = (float *)param.x;
    incx   = param.incx;
    beta   = param.beta;
    y      = (float *)param.y;
    incy   = param.incy;
    
    ssymv( lapack_const(uplo), &n, (const float *)&alpha,
           (float *)a, &lda, (float *)x, &incx,
           (const float *)&beta, (float *)y, &incy);
}

//=========================================================================================
void call_strsm(magma_mic_strsm_param param)
{
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m, n, lda, ldb;
    float alpha, *a, *b;
    
    side   = param.side;
    uplo   = param.uplo;
    transa = param.transa;
    diag   = param.diag;
    m      = param.m;
    n      = param.n;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    b      = (float *)param.b;
    ldb    = param.ldb;
    
    //printf("STRSM: %c %c %c %c %d %d %f 0x%lx %d 0x%lx %d\n", side, uplo, transa, diag, m, n, alpha, (off_t)a, lda, (off_t)b, ldb);
    strsm( lapack_const(side), lapack_const(uplo), lapack_const(transa), lapack_const(diag),
           &m, &n, (const float *)&alpha, (float *)a, &lda,
           (float *)b, &ldb);
}

//=========================================================================================
void call_strsv(magma_mic_strsv_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_diag_t diag;
    magma_int_t n, lda, incx;
    float alpha, *a, *dx;
    
    uplo  = param.uplo;
    trans = param.trans;
    diag  = param.diag;
    n     = param.n;
    a     = (float *)param.a;
    lda   = param.lda;
    dx    = (float *)param.dx;
    incx  = param.incx;
    
    strsv( lapack_const(uplo), lapack_const(trans), lapack_const(diag),
           &n, (float *)a, &lda, (float *)dx, &incx);
}

//=========================================================================================
void call_strmv(magma_mic_strmv_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_diag_t diag;
    magma_int_t n, lda, incx;
    float alpha, *a, *dx;
    
    uplo  = param.uplo;
    trans = param.trans;
    diag  = param.diag;
    n     = param.n;
    a     = (float *)param.a;
    lda   = param.lda;
    dx    = (float *)param.dx;
    incx  = param.incx;
    
    strmv( lapack_const(uplo), lapack_const(trans), lapack_const(diag),
           &n, (float *)a, &lda, (float *)dx, &incx);
}

//=========================================================================================
void call_strmm(magma_mic_strmm_param param)
{
    magma_side_t  side;
    magma_uplo_t  uplo;
    magma_trans_t transa;
    magma_diag_t  diag;
    magma_int_t m, n, lda, ldb;
    float alpha, *a, *b;

    side   = param.side;
    uplo   = param.uplo;
    transa = param.transa;
    diag   = param.diag;
    m      = param.m;
    n      = param.n;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    b      = (float *)param.b;
    ldb    = param.ldb;

    //printf("STRMM: %c %c %c %c %d %d %f 0x%lx %d 0x%lx %d\n", side, uplo, transa, diag, m, n, alpha, (off_t)a, lda, (off_t)b, ldb);
    strmm( lapack_const(side), lapack_const(uplo), lapack_const(transa), lapack_const(diag),
           &m, &n, (const float *)&alpha, (float *)a, &lda,
           (float *)b, &ldb);
}

//=========================================================================================
//magmablas our ssyrk Azzam
//=========================================================================================
void magmablas_ssyrk_mic0(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magma_int_t nb,
    float alpha, float *a, magma_int_t lda, magma_int_t aoff,
    float beta,  float *c, magma_int_t ldc, magma_int_t offset)
{
    #define dA(i, j) (a + (i) + (j)*lda + (aoff) )
    #define dC(i, j) (c + (i) + (j)*ldc)

    float cbeta  = MAGMA_S_MAKE( beta,  0. );
    float calpha = MAGMA_S_MAKE( alpha, 0. );

    magma_int_t m, ib, ioff;
    magma_int_t blockoffset = offset % nb;

    // loop over all blocks and does A*A'
    // blockoffset is offset within first block; for subsequent blocks it is 0
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        ioff   = i + offset;                  // global index in parent matrix
        // C[i:n,i] += A[i:n,0] * A[i,0]'
        m = n - i;
        sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &m, &ib, &k,
               (const float *)&calpha, (float *)(dA(i,0)),       &lda,
                                               (float *)(dA(i,0)),       &lda,
               (const float *)&cbeta,  (float *)(dC(ioff,ioff)), &ldc );
        blockoffset = 0;
    }
    
    #undef dA
    #undef dC
}

//=========================================================================================
//magmablas our ssyrk version2
//=========================================================================================
void magmablas_ssyrk_mic(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magma_int_t nb,
    float alpha, float *a, magma_int_t lda, magma_int_t aoff,
    float beta,  float *c, magma_int_t ldc, magma_int_t offset)
{
    #define dA(i, j) (a + (i) + (j)*lda + (aoff) )
    #define dC(i, j) (c + (i) + (j)*ldc)

    float cbeta  = MAGMA_S_MAKE( beta,  0. );
    float calpha = MAGMA_S_MAKE( alpha, 0. );

    //if (n <= 3840)
    //        nb = 1200;
    //else
    //  nb = 960;

    magma_int_t m, ib, ioff;
    magma_int_t blockoffset = offset % nb;

    if (n <= 8640) {
        // loop over all blocks and does A*A'
        // blockoffset is offset within first block; for subsequent blocks it is 0
        for( magma_int_t i = 0; i < n; i += ib ) {
            ib     = min( nb-blockoffset, n-i );  // block size
            ioff   = i + offset;                  // global index in parent matrix
            // C[i:n,i] += A[i:n,0] * A[i,0]'
            m = n - i;
            sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &m, &ib, &k,
                            (const float *)&calpha, (float *)(dA(i,0)),       &lda,
                                                            (float *)(dA(i,0)),       &lda,
                            (const float *)&cbeta,  (float *)(dC(ioff,ioff)), &ldc );
            blockoffset = 0;
        }
    } else {
        magma_int_t i_960 = n / (2 * 960);
        magma_int_t ngemm = i_960 * 960;
        magma_int_t nrema = n - ngemm;
        //gemm for square block
        sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &ngemm, &nrema, &k,
                        (const float *)&calpha, (float *)(dA(nrema, 0)), &lda,
                                                        (float *)(dA(0, 0)),     &lda,
                        (const float *)&cbeta,  (float *)(dC(nrema, 0)), &ldc );

        //two syrk call
        magmablas_ssyrk_mic(MagmaLower, MagmaNoTrans,
                        nrema, k, nb, alpha, a, lda, 0,
                        beta, c, ldc, 0);

        magmablas_ssyrk_mic(MagmaLower, MagmaNoTrans,
                        ngemm, k, nb, alpha, dA(nrema, 0), lda, 0,
                        beta, dC(nrema, nrema), ldc, 0);
    }
    
    #undef dA
    #undef dC
}

//=========================================================================================
void call_ssyrk(magma_mic_ssyrk_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n, k, lda, ldc;
    float alpha, beta;
    float *a, *c;

    uplo  = param.uplo;
    trans = param.trans;
    n     = param.n;
    k     = param.k;
    alpha = param.alpha;
    a     = (float *)param.a;
    lda   = param.lda;
    beta  = param.beta;
    c     = (float *)param.c;
    ldc   = param.ldc;

    //printf("SSYRK: %c %c %d %d %f 0x%lx %d %f 0x%lx %d\n", uplo, trans, n, k, alpha, (off_t)a, lda, beta, (off_t)c, ldc);

    // call MKL ssyrk
    //ssyrk( lapack_const(uplo), lapack_const(trans),
    //       &n, &k, &alpha, (float *)a, &lda,
    //       &beta, (float *)c, &ldc);
   
     
    magma_int_t nb = 960;
    magmablas_ssyrk_mic(MagmaLower, MagmaNoTrans,
                     n, k, nb, alpha, a, lda, 0,
                     beta, c, ldc, 0);
}

//=========================================================================================
void magmablas_ssyrk_mmic(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k,
    float alpha, float *a, magma_int_t lda, magma_int_t aoff,
    float beta,  float *c, magma_int_t ldc, magma_int_t offset,
    magma_int_t nmic, magma_int_t nb, magma_int_t my_id)
{
    #define dA(i, j) (a + (i) + (j)*lda + (aoff) )
    #define dC(i, j) (c + (i) + (j)*ldc)

    float cbeta  = MAGMA_S_MAKE( beta,  0. );
    float calpha = MAGMA_S_MAKE( alpha, 0. );

    magma_int_t rows, ib, ioff, iblock, idev, di, s;

    // loop over all blocks
    // Faster to have two loops: first does A*B', second does B*A'
    // blockoffset is offset within first block; for subsequent blocks it is 0
    magma_int_t blockoffset = offset % nb;
    float tt = 0;
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        ioff   = i + offset;                  // global index in parent matrix
        iblock = (ioff / nb) / nmic;          // local block id
        idev   = (ioff / nb) % nmic;          // device with this block
        di     = iblock*nb + blockoffset;     // local index in parent matrix

        // C[i:n,i] += A[i:n,0] * B[i,0]'
        //printf( "sgemm  n=%4d, ib=%4d, k=%4d, i=%4d\n", n-i, ib, k, i );
        if (idev == my_id) {
            rows = n - i;
            sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &rows, &ib, &k,
                   (const float *)&calpha, (float *)dA(i,0),     &lda,
                                                   (float *)dA(i,0),     &lda,
                   (const float *)&cbeta,  (float *)dC(ioff,di), &ldc);
        }

        blockoffset = 0;
    }
    
    #undef dA
    #undef dC
}

//=========================================================================================
void call_ssyrk_mmic(magma_mic_ssyrk_mmic_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n, k, lda, ldb, ldc, aoff, boff, offset, nb, my_id, nmic;
    float alpha, beta;
    float *a, *b, *c;

    uplo   = param.uplo;
    trans  = param.trans;
    n      = param.n;
    k      = param.k;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    aoff   = param.aoff;
    beta   = param.beta;
    c      = (float *)param.c;
    ldc    = param.ldc;
    offset = param.offset;
    nmic   = param.nmic;
    nb     = param.nb;
    my_id  = param.my_id;

    //printf("SSYRK_MMIC: %c %c %d %d %f 0x%lx %d %f 0x%lx %d\n", uplo, trans, n, k, alpha, (off_t)a, lda, beta, (off_t)c, ldc);

    magmablas_ssyrk_mmic(
        uplo, trans, n, k,
        alpha, a, lda, aoff,
        beta, c, ldc, offset,
        nmic, nb, my_id);
}

//=========================================================================================
//magmablas our ssyr2k Azzam
//=========================================================================================
void magmablas_ssyr2k_mic(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magma_int_t nb,
    float alpha,
    float *a, magma_int_t lda,
    float *b, magma_int_t ldb,
    float beta,
    float *c, magma_int_t ldc)
{
    #define dA(i, j) (a + (i) + (j)*lda)
    #define dB(i, j) (b + (i) + (j)*ldb)
    #define dC(i, j) (c + (i) + (j)*ldc)

    const float c_one = MAGMA_S_ONE;
    float cbeta    = MAGMA_S_MAKE( beta, 0. );
    float cnjalpha = MAGMA_S_CNJG( alpha );

    magma_int_t m, ib;
    // loop over all blocks and does A*A'
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb, n-i );  // block size
        m = n - i;
        //printf("voici m %d     n %d    k %d \n",m,ib,k);
        // C[i:n,i] += A[i:n,0] * A[i,0]'
        sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &m, &ib, &k,
               (const float *)&alpha, (float *)(dA(i,0)), &lda,
                                              (float *)(dB(i,0)), &ldb,
               (const float *)&cbeta, (float *)(dC(i,i)), &ldc );

        // C[i:n,i] += A[i:n,0] * A[i,0]'
        sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &m, &ib, &k,
               (const float *)&cnjalpha, (float *)(dB(i,0)), &ldb,
                                                 (float *)(dA(i,0)), &lda,
               (const float *)&c_one,    (float *)(dC(i,i)), &ldc );
    }
    
    #undef dA
    #undef dB
    #undef dC
}

//=========================================================================================
void call_ssyr2k(magma_mic_ssyr2k_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n, k, lda, ldb, ldc;
    float alpha;
    float beta;
    float *a, *b, *c;

    uplo  = param.uplo;
    trans = param.trans;
    n     = param.n;
    k     = param.k;
    alpha = param.alpha;
    a     = (float *)param.a;
    lda   = param.lda;
    b     = (float *)param.b;
    ldb   = param.ldb;
    beta  = param.beta;
    c     = (float *)param.c;
    ldc   = param.ldc;

    //printf("SSYR2K: %c %c %d %d %f 0x%lx %d %f 0x%lx %d\n", uplo,trans, n,k, alpha, (off_t)a,lda, beta, (off_t)c, ldc);
   
    if (uplo == MagmaUpper) {
           ssyr2k( lapack_const(uplo), lapack_const(trans),
                   &n, &k, (float *)&alpha,
                           (float *)a, &lda,
                           (float *)b, &ldb,
                   &beta,  (float *)c, &ldc);
    } else {
           magma_int_t nb = 960;
           magmablas_ssyr2k_mic( MagmaLower, MagmaNoTrans,
                           n, k, nb, alpha, a, lda,
                           b, ldb,
                           beta, c, ldc);
    }
}

//=========================================================================================
//magmablas our ssyr2k_mmic Azzam
//=========================================================================================
void magmablas_ssyr2k_mmic(
    magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k,
    float alpha,
    float *a, magma_int_t lda, magma_int_t aoff,
    float *b, magma_int_t ldb, magma_int_t boff,
    float beta,
    float *c, magma_int_t ldc,  magma_int_t offset,
    magma_int_t nmic, magma_int_t nb, magma_int_t my_id)
{
    #define dA(i, j) (a + (i) + (j)*lda + (aoff) )
    #define dB(i, j) (b + (i) + (j)*ldb + (boff) )
    #define dC(i, j) (c + (i) + (j)*ldc)

    const float c_one = MAGMA_S_ONE;
    float cbeta = MAGMA_S_MAKE( beta, 0. );


    magma_int_t rows, ib, ioff, iblock, idev, di, s;

    // loop over all blocks
    // Faster to have two loops: first does A*B', second does B*A'
    // blockoffset is offset within first block; for subsequent blocks it is 0
    magma_int_t blockoffset = offset % nb;
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        ioff   = i + offset;                  // global index in parent matrix
        iblock = (ioff / nb) / nmic;          // local block id
        idev   = (ioff / nb) % nmic;          // device with this block
        di     = iblock*nb + blockoffset;     // local index in parent matrix

        // C[i:n,i] += A[i:n,0] * B[i,0]'
        //printf( "sgemm  n=%4d, ib=%4d, k=%4d, i=%4d\n", n-i, ib, k, i );
        if (idev == my_id) {
            rows = n - i;
            sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &rows, &ib, &k,
                   (const float *)&alpha, (float *)dA(i,0),     &lda,
                                                  (float *)dB(i,0),     &ldb,
                   (const float *)&cbeta, (float *)dC(ioff,di), &ldc);
        }

        blockoffset = 0;
    }

    blockoffset = offset % nb;
    alpha = MAGMA_S_CNJG( alpha );
    for( magma_int_t i = 0; i < n; i += ib ) {
        ib     = min( nb-blockoffset, n-i );  // block size
        ioff   = i + offset;                  // global index in parent matrix
        iblock = (ioff / nb) / nmic;          // local block id
        idev   = (ioff / nb) % nmic;          // device with this block
        di     = iblock*nb + blockoffset;     // local index in parent matrix

        // C[i:n,i] += B[i:n,0] * A[i,0]'
        //printf( "sgemm  n=%4d, ib=%4d, k=%4d, i=%4d\n", n-i, ib, k, i );
        if (idev == my_id) {
            rows = n - i;
            sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans), &rows, &ib, &k,
                   (const float *)&alpha, (float *)dB(i,0),     &ldb,
                                                  (float *)dA(i,0),     &lda,
                   (const float *)&c_one, (float *)dC(ioff,di), &ldc);
        }
        blockoffset = 0;
    }
    
    #undef dA
    #undef dB
    #undef dC
}

//=========================================================================================
void call_ssyr2k_mmic(magma_mic_ssyr2k_mmic_param param)
{
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n, k, lda, ldb, ldc, aoff, boff, offset, nb, my_id, nmic;
    float alpha;
    float beta;
    float *a, *b, *c;

    uplo   = param.uplo;
    trans  = param.trans;
    n      = param.n;
    k      = param.k;
    alpha  = param.alpha;
    a      = (float *)param.a;
    lda    = param.lda;
    aoff   = param.aoff;
    b      = (float *)param.b;
    ldb    = param.ldb;
    boff   = param.boff;
    beta   = param.beta;
    c      = (float *)param.c;
    ldc    = param.ldc;
    offset = param.offset;
    nmic   = param.nmic;
    nb     = param.nb;
    my_id  = param.my_id;

    //printf("SSYR2K_MMIC: %c %c %d %d %f 0x%lx %d %f 0x%lx %d\n", uplo, trans, n, k, alpha, (off_t)a, lda, beta, (off_t)c, ldc);

    magmablas_ssyr2k_mmic(
        uplo, trans, n, k,
        alpha, a, lda, aoff,
        b, ldb, boff,
        beta, c, ldc, offset,
        nmic, nb, my_id);
}

//=========================================================================================
void call_slarft(magma_mic_slarft_param param)
{
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t n, k, ldv, ldt;
    float *v, *tau, *t;
    
    direct = param.direct;
    storev = param.storev;
    n      = param.n;
    k      = param.k;
    v      = (float *)param.v;
    ldv    = param.ldv;
    tau    = (float *)param.tau;
    t      = (float *)param.t;
    ldt    = param.ldt;
    
    //printf("SLARFT: %c %c %d %d 0x%lx %d ox%lx 0x%lx %d\n", direct, storev, n, k, (off_t)v, ldv, (off_t)tau, (off_t)t, ldt);
    
    slarft( lapack_const(direct), lapack_const(storev),
            &n, &k, (float *)v, &ldv,
            (float *)tau, (float *)t, &ldt);
}

//=========================================================================================
void call_slarfb(magma_mic_slarfb_param param)
{
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m, n, k, ldv, ldt, ldc, ldwork;
    float *v, *t, *c, *work;

    side   = param.side;
    trans  = param.trans;
    direct = param.direct;
    storev = param.storev;
    m      = param.m;
    n      = param.n;
    k      = param.k;
    v      = (float *)param.v;
    ldv    = param.ldv;
    t      = (float *)param.t;
    ldt    = param.ldt;
    c      = (float *)param.c;
    ldc    = param.ldc;
    work   = (float *)param.work;
    ldwork = param.ldwork;

    slarfb( lapack_const(side), lapack_const(trans), lapack_const(direct), lapack_const(storev),
            &m, &n, &k, (float *)v, &ldv, (float *)t, &ldt,
            (float *)c, &ldc, (float *)work, &ldwork);
}

//=========================================================================================
//magmablas our SLARFB based on GEMMs Azzam
//=========================================================================================
void call_slarfb_gemm(magma_mic_slarfb_gemm_param param)
{
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m, n, k, ldv, ldt, ldc, ldwork, ldworkvt;
    float *v, *t, *c, *work, *workvt;
    
    side     = param.side;
    trans    = param.trans;
    direct   = param.direct;
    storev   = param.storev;
    m        = param.m;
    n        = param.n;
    k        = param.k;
    v        = (float *)param.v;
    ldv      = param.ldv;
    t        = (float *)param.t;
    ldt      = param.ldt;
    c        = (float *)param.c;
    ldc      = param.ldc;
    work     = (float *)param.work;
    ldwork   = param.ldwork;
    workvt   = (float *)param.workvt;
    ldworkvt = param.ldworkvt;
    
    float c_zero    = MAGMA_S_ZERO;
    float c_one     = MAGMA_S_ONE;
    float c_neg_one = MAGMA_S_NEG_ONE;

    /* Function Body */
    if (m <= 0 || n <= 0) {
        return;
    }

    // opposite of trans
    magma_trans_t transt;
    if (trans == MagmaNoTrans)
        transt = MagmaConjTrans;
    else
        transt = MagmaNoTrans;
    
    // whether T is upper or lower triangular
    magma_uplo_t uplo;
    if (direct == MagmaForward)
        uplo = MagmaUpper;
    else
        uplo = MagmaLower;
    
    // whether V is stored transposed or not
    magma_int_t notransV, transV;
    if (storev == MagmaColumnwise) {
        notransV = MagmaNoTrans;
        transV   = MagmaConjTrans;
    }
    else {
        notransV = MagmaConjTrans;
        transV   = MagmaNoTrans;
    }

    if ( side == MagmaLeft ) {
        // Form H C or H' C
        // Comments assume H C.
        // When forming H' C, T gets transposed via transt for m >= n or by trans for m < n.
        
        // W = C' V
        sgemm( lapack_const(MagmaConjTrans), lapack_const(notransV),
               &n, &k, &m,
               (const float *)&c_one,  (float *)c,    &ldc,
                                               (float *)v,    &ldv,
               (const float *)&c_zero, (float *)work, &ldwork);

        if (m < n) {
            // W2 = V T
            sgemm( lapack_const(notransV), lapack_const(trans),
                   &m, &k, &k,
                   (const float *)&c_one,  (float *)v,      &ldv,
                                                   (float *)t,      &ldt,
                   (const float *)&c_zero, (float *)workvt, &ldworkvt);
                        
            // C = C - W2 W' = C - V T V' C = (I - V T V') C = H C
            sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaConjTrans),
                   &m, &n, &k,
                   (const float *)&c_neg_one, (float *)workvt, &ldworkvt,
                                                      (float *)work,   &ldwork,
                   (const float *)&c_one,     (float *)c,      &ldc);
        } else {
            // W2 = W T' = C' V T'
            sgemm( lapack_const(MagmaNoTrans), lapack_const(transt),
                   &n, &k, &k,
                   (const float *)&c_one,  (float *)work,   &ldwork,
                                                   (float *)t,      &ldt,
                   (const float *)&c_zero, (float *)workvt, &ldworkvt);
                                                 
            // C = C - V W2' = C - V T V' C = (I - V T V') C = H C
            sgemm( lapack_const(notransV), lapack_const(MagmaConjTrans),
                   &m, &n, &k,
                   (const float *)&c_neg_one, (float *)v,      &ldv,
                                                      (float *)workvt, &ldworkvt,
                   (const float *)&c_one,     (float *)c,      &ldc);
        }
    }
    else {
        // Form C H or C H'
        // Comments assume C H.
        // When forming C H', T gets transposed via trans.
        
        // W = C V
        sgemm( lapack_const(MagmaNoTrans), lapack_const(notransV),
               &m, &k, &n,
               (const float *)&c_one,  (float *)c,    &ldc,
                                               (float *)v,    &ldv,
               (const float *)&c_zero, (float *)work, &ldwork);
        if (m <= n) {
            // W2 = W T = C V T
            sgemm( lapack_const(MagmaNoTrans), lapack_const(trans),
                   &m, &k, &k,
                   (const float *)&c_one,  (float *)work,   &ldwork,
                                                   (float *)t,      &ldt,
                   (const float *)&c_zero, (float *)workvt, &ldworkvt);
            
            // C = C - W2 V' = C - C V T V' = C (I - V T V') = C H
            sgemm( lapack_const(MagmaNoTrans), lapack_const(transV),
                   &m, &n, &k,
                   (const float *)&c_neg_one, (float *)work, &ldwork,
                                                      (float *)v,    &ldv,
                   (const float *)&c_one,     (float *)c,    &ldc);
        } else {
            // W2 = T V'
            sgemm( lapack_const(trans), lapack_const(transV),
                   &k, &n, &k,
                   (const float *)&c_one,  (float *)t,      &ldt,
                                                   (float *)v,      &ldv,
                   (const float *)&c_zero, (float *)workvt, &ldworkvt);
            // C = C - W W2 = C - C V T V' = C (I - V T V') = C H
            sgemm( lapack_const(MagmaNoTrans), lapack_const(MagmaNoTrans),
                   &m, &n, &k,
                   (const float *)&c_neg_one, (float *)work,   &ldwork,
                                                      (float *)workvt, &ldworkvt,
                   (const float *)&c_one,     (float *)c,      &ldc);
        }
    }
}

//=========================================================================================
void call_slaset(magma_mic_slaset_param param)
{
    magma_uplo_t uplo;
    magma_int_t m, n, lda;
    float alpha, beta;
    float *dA;

    uplo  = param.uplo;
    m     = param.m;
    n     = param.n;
    alpha = param.alpha;
    beta  = param.beta;
    dA    = (float *)param.dA;
    lda   = param.lda;

    slaset( lapack_const(uplo), &m, &n,
            (const float *)&alpha, (const float *)&beta,
            (float *)dA, &lda);
}

//=========================================================================================
void call_stranspose(magma_mic_stranspose_param param)
{
        /******************************************************
         * _mm512_load_pd -- for loading
         * _mm512_i32lo[ext]scatter_pd
         * _mm512_i32loscatter_pd is the simplified version of ...ext...
         * they do the same thing, the latter needs less arguments.
         * **************************************************/
        //        printf("entered stranpose\n");
        //        fflush(stdout);
        /*
           float *odata, *idata;
           magma_int_t ldo,ldi, m, n;
           magma_int_t num_threads;
           magma_int_t tid;
           magma_int_t index[16], i;
           __M512S _reg;
           __m512i _index;
           float *my_head, *loop_head, *dest_head;
           magma_int_t num_cols, num_cols_g, col, iter, num_iter, num_rows_g, num_rows;

           odata = (float *) param.odata;
           ldo   = param.ldo;
           idata = (float *) param.idata;
           ldi   = param.ldi;
           m     = param.m;
           n     = param.n;

           if (m == 0 || n == 0) {
           return;
           }
           if (m <= n) {
           for (i = 0; i < 16; i++) {
           index[i] = i*SREG_WIDTH*ldo;
           }
        // 62 cores, 4 hardware threads per core. Leave out one core for the OS
        // (62 - 1)*4 = 244

        num_threads = 244;
        num_cols_g =        (n + num_threads - 1)/num_threads;
        num_iter = (int) m*1.0/SREG_WIDTH;
        _index = _mm512_set_epi32(index[15], index[14], index[13], index[12],
        index[11], index[10], index[9], index[8], index[7], index[6],
        index[5], index[4], index[3], index[2], index[1], index[0]);

#pragma omp parallel num_threads(num_threads) private(tid, col, num_cols, iter,\
my_head, loop_head, dest_head, _reg)
{
tid = omp_get_thread_num();
num_cols = num_cols_g;
if (tid == (num_threads - 1) && (n%num_cols_g != 0)) {
num_cols = n%num_cols_g;
}
// starting point of my section, constant for each thread
my_head = idata + ldi*(tid*num_cols_g);
for (iter = 0; iter < num_iter; iter++) { // loop inside each column
for (col = 0; col < num_cols; col++) { // loop over each column
if (tid*num_cols_g + col < n) {
        // starting point of the inner loop
        loop_head = my_head + col*ldi + iter*SREG_WIDTH;
        dest_head = odata + (iter*SREG_WIDTH)*ldo + (tid*num_cols_g + col);
        // load 8 real floating point nubmers from address
        // mt into a float64 vector.
        _reg = _MM512_LOAD_PPS( (void const *)loop_head);
        //                                        _mm512_load_pd( (void const *)loop_head);

        // this intrinsic needs int32 indices, but a 512 register
        // contains 16 int32 integers, and there is only one intrinsic
        // to set all 16 positoins of the register. So _index contains
        // 16 int32 integers.
        _MM512_I32LOEXTSCATTER_PPS((void *) dest_head, _index, _reg,
        _MM_DOWNCONV_PS_NONE, 1, _MM_HINT_NONE);
        }
        }
        }
        }
        } else {
        // init index[], it's for scattering the entries to the dest matrix
        for (i = 0; i < 16; i++) {
        index[i] = i*SREG_WIDTH*ldo;
        }

        // 62 cores, 4 hardware threads per core. Leave out one core for the OS
        // (62 - 1)*4 = 244
        num_threads = 244;
        // number of rows in each group
        num_rows_g = (m/SREG_WIDTH + num_threads - 1)/num_threads*SREG_WIDTH;
        _index = _mm512_set_epi32(index[15], index[14], index[13], index[12],
                        index[11], index[10], index[9], index[8], index[7], index[6],
                        index[5], index[4], index[3], index[2], index[1], index[0]);

#pragma omp parallel num_threads(num_threads) private(tid, col, num_rows, iter,\
                loop_head, dest_head, _reg, num_iter)
        {
                tid = omp_get_thread_num();
                // compute the number of rows I need to work on
                num_rows = num_rows_g;
                if (tid == (num_threads - 1) && (m%num_rows_g != 0)) {
                        num_rows = m%num_rows_g;
                }
                num_iter = (int) num_rows*1.0/SREG_WIDTH;

                for (iter = 0; iter < num_iter; iter++) {
                        if (tid*num_rows_g + iter*SREG_WIDTH < m) {
                                for (col = 0; col < n; col++) {
                                        loop_head = idata + (tid*num_rows_g + iter*SREG_WIDTH) + ldi*col;
                                        dest_head = odata + ldo*(tid*num_rows_g + iter*SREG_WIDTH) + col;

                                        _reg = _MM512_LOAD_PPS((void const *) loop_head);
                                        _MM512_I32LOEXTSCATTER_PPS((void *) dest_head, _index, _reg,
                                                        _MM_DOWNCONV_PS_NONE, 1, _MM_HINT_NONE);
                                }
                        }
                }
        }
}
*/
return;
}

//=========================================================================================
void call_stranspose_mkl(magma_mic_stranspose_param param)
{
    float *odata, *idata;
    magma_int_t ldo,ldi, m, n;
    magma_int_t num_threads;
    magma_int_t tid;
    magma_int_t index[16], i;
    //  _M512 _reg;
    //  _M512I _index;
    float *my_head, *loop_head, *dest_head;
    magma_int_t num_cols, num_cols_g, col, iter, num_iter;
    
    odata = (float *) param.odata;
    ldo   = param.ldo;
    idata = (float *) param.idata;
    ldi   = param.ldi;
    m     = param.m;
    n     = param.n;
    float c_one = MAGMA_S_ONE;
    
    mkl_somatcopy('C', 'T', m, n, *((float *)(&c_one)), (float *)idata, ldi,
                    (float *)odata, ldo);
}

//=========================================================================================
void call_slaswp(magma_mic_slaswp_param param)
{
    magma_int_t n, k1, k2, lda, incx;
    float *d_A;
    magma_int_t *d_ipiv;
                     
    n      = param.n;
    d_A    = (float *) param.d_A;
    lda    = param.lda;
    k1     = param.k1;
    k2     = param.k2;
    d_ipiv = (magma_int_t *) param.d_ipiv;
    incx   = param.incx;
    
    //printf("n: %d lda: %d k1: %d k2: %d incx: %d\n", n, lda, k1, k2, incx);
    slaswp(&n, (float *)d_A, &lda, &k1, &k2, (magma_int_t *)d_ipiv, &incx);
}

//=========================================================================================
void call_sswap(magma_mic_sswap_param param)
{
    magma_int_t n, lda1, lda2;
    float tmp, *dA1T, *dA2T;
                     
    n       = param.n;
    dA1T    = (float *) param.dA1T;
    lda1    = param.lda1;
    dA2T    = (float *) param.dA2T;
    lda2    = param.lda2;
    
    sswap(&n, (float *)dA1T, &lda1, (float *)dA2T, &lda2);
}

//=========================================================================================
void call_strsmgemm(magma_mic_strsmgemm_param param)
{
    float gtrsmflops, ggemmflops, mic_trsmtime, mic_gemmtime;

    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t ttransa;
    magma_diag_t diag;
    magma_int_t tm, tn, tlda, tldb;
    float talpha, *ta, *tb;

    side    = param.trsm_param.side;
    uplo    = param.trsm_param.uplo;
    ttransa = param.trsm_param.transa;
    diag    = param.trsm_param.diag;
    tm      = param.trsm_param.m;
    tn      = param.trsm_param.n;
    talpha  = param.trsm_param.alpha;
    ta      = (float *)param.trsm_param.a;
    tlda    = param.trsm_param.lda;
    tb      = (float *)param.trsm_param.b;
    tldb    = param.trsm_param.ldb;

    mic_trsmtime = dsecnd();

    strsm( lapack_const(side), lapack_const(uplo), lapack_const(ttransa), lapack_const(diag),
           &tm, &tn, (const float *)&talpha, (float *)ta, &tlda,
           (float *)tb, &tldb);

    mic_trsmtime = dsecnd() - mic_trsmtime;

    gtrsmflops = 0;
    if (side == MagmaLeft)
        gtrsmflops = MICFLOPS_TRSM_L((float)tm, (float)tn) * 1e-9;
    else if (side == MagmaRight)
        gtrsmflops = MICFLOPS_TRSM_R((float)tm, (float)tn) * 1e-9;

    magma_trans_t transa, transb;
    magma_int_t m, n, k, lda, ldb, ldc;
    float alpha, beta, *a, *b, *c;

    transa = param.gemm_param.transa;
    transb = param.gemm_param.transb;
    m      = param.gemm_param.m;
    n      = param.gemm_param.n;
    k      = param.gemm_param.k;
    alpha  = param.gemm_param.alpha;
    a      = (float *)param.gemm_param.a;
    lda    = param.gemm_param.lda;
    b      = (float *)param.gemm_param.b;
    ldb    = param.gemm_param.ldb;
    beta   = param.gemm_param.beta;
    c      = (float *)param.gemm_param.c;
    ldc    = param.gemm_param.ldc;

    //printf("SGEMM: %c %c %d %d %d %f 0x%lx %d 0x%lx %d %f 0x%lx %d\n", transa, transb, m, n, k, alpha, (off_t)a, lda, (off_t)b, ldb, beta, (off_t)c, ldc);

    mic_gemmtime = dsecnd();

    sgemm( lapack_const(transa), lapack_const(transb),
           &m, &n, &k, (const float *)&alpha, (float *)a, &lda,
           (float *)b, &ldb, (const float *)&beta,
           (float *)c, &ldc);

    mic_gemmtime = dsecnd() - mic_gemmtime;

    ggemmflops = MICFLOPS_GEMM((float)m, (float)n, (float)k) * 1e-9;

    //printf("DTRSMGEMM: %8.4lf( %8.4lf )\t %8.4lf( %8.4lf )\n", gtrsmflops / mic_trsmtime, mic_trsmtime * 1000, ggemmflops / mic_gemmtime, mic_gemmtime * 1000);
}

//=========================================================================================


//=========================================================================================
void call_slange(magma_mic_slange_param param)
{

    magma_norm_t                    norm;
    magma_int_t                     m;
    magma_int_t                     n;
    magmaFloat_const_ptr    dA; 
    magma_int_t                     ldda;
    magmaFloat_ptr                 dwork;
    float                          *ret;

    norm    =  param.norm;   
    m       =  param.m;    
    n       =  param.n;    
    dA      =  param.dA;   
    ldda    =  param.ldda;      
    dwork   =  param.dwork;
    ret     =  param.ret;

    *ret = slange( lapack_const(norm), &m, &n,
            (float *)dA, &ldda, (float*) dwork);

}

//=========================================================================================

//=========================================================================================
void call_slacpy(magma_mic_slacpy_param param)
{
    magma_uplo_t                    uplo;
    magma_int_t                     m;
    magma_int_t                     n;
    magmaFloat_const_ptr    dA;
    magma_int_t                     ldda;
    magmaFloat_ptr          dB;
    magma_int_t                     lddb;

    uplo    =  param.uplo           ;
    m       =  param.m              ;
    n       =  param.n              ;
    dA      =  param.dA             ;
    ldda    =  param.ldda           ;
    dB      =  param.dB             ;
    lddb    =  param.lddb           ;

    slacpy( lapack_const(uplo), &m, &n,
            (float *)dA, &ldda,
            (float *)dB, &lddb );
}

//=========================================================================================

//=========================================================================================
void call_isamax(magma_mic_isamax_param param)
{


    
    magma_int_t                     n;
    magmaFloat_const_ptr    dx;
    magma_int_t                     incx;
    magma_int_t                    *ret;

    n       =  param.n              ;
    dx      =  param.dx             ;
    incx    =  param.incx           ;
    ret     =  param.ret            ;
    *ret = isamax(  &n,
            (float *)dx, &incx );


}

//=========================================================================================
//=========================================================================================

void saxpycp2( magma_int_t m, magmaFloat_ptr r, magmaFloat_ptr x,magmaFloat_ptr b)
{
#pragma omp parallel for
    for ( int i = 0; i < m; i++ ) {
        x[i] = MAGMA_S_ADD( x[i], r[i] );
        r[i] = b[i];
    }
}

void call_saxpycp2(magma_mic_saxpycp2_param param)
{


    
    magma_int_t                     m;
    float    *r;
    float    *x;
    float    *b;

    m       =  param.m              ;
    r       =  param.r              ;
    x       =  param.x              ;
    b       =  param.b              ;

    saxpycp2( m ,r, x, b);
}

//=========================================================================================

