/*
 *   -- micMAGMA (version 1.3.1) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 *   @precisions mixed zc -> ds
 *
 *   This is included in magma_mic_server.cpp,
 *   inside a switch { } block in the do_work() function.
 */

case magma_mic_ZLAG2C:
{
    magma_mic_zlag2c_param param;
    if (mic_recv(&param, sizeof(param)) == MIC_FAILURE) {
        printf("scif_recv failed for ZLAG2C\n");
        return;
    }
    
    mic_time = dsecnd();
    call_zlag2c(param);
    mic_time = dsecnd() - mic_time;
    
    break;
}

case magma_mic_CLAG2Z:
{
    magma_mic_clag2z_param param;
    if (mic_recv(&param, sizeof(param)) == MIC_FAILURE) {
        printf("scif_recv failed for CLAG2Z\n");
        return;
    }
    
    mic_time = dsecnd();
    call_clag2z(param);
    mic_time = dsecnd() - mic_time;
    
    break;
}


case magma_mic_ZCGESV:
{
    magma_mic_zcgesv_param param;
    if (mic_recv(&param, sizeof(param)) == MIC_FAILURE) {
        printf("scif_recv failed for ZCGESV\n");
        return;
    }
    
    mic_time = dsecnd();
    call_zcgesv(param);
    mic_time = dsecnd() - mic_time;
    
    break;
}
